package com.wincornixdorf.vnc.gui;

import java.awt.BorderLayout;

import javax.swing.BorderFactory;
import javax.swing.Icon;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.SwingConstants;
import javax.swing.border.BevelBorder;

/**The ConcealablePanel is nothing but a plain JPanel with a Label displaying
a text and an icon. These Panels are being used throughout the VNCViewer to
display all sorts of controls and widgets which need not be on the screen all
the time and may therefore be concealed. The purpose of this class it to ensure
all such widgets have a common look and feel by implementing them in a class of
their own. At the moment the widget does not provide any Actions or methods of
its own to hide and show the controls. This may change in the future.*/
public class ConcealablePanel extends JPanel {

    private static final long serialVersionUID = 1L;

    public ConcealablePanel( String caption, Icon icon, JComponent c) {
        super( new BorderLayout());

        setBorder( BorderFactory.createBevelBorder( BevelBorder.RAISED));

        // This is the label which gets used as a "caption" for a fake frame
        JLabel l = new JLabel( caption, icon, SwingConstants.LEFT);
        l.setBorder( BorderFactory.createEtchedBorder( BevelBorder.LOWERED));

        add( l, BorderLayout.NORTH);
        add( c, BorderLayout.CENTER);

        setVisible( false);
    }
}
