package com.wincornixdorf.vnc.rfb.decoder;

import java.awt.Color;
import java.io.DataInputStream;

import com.wincornixdorf.vnc.rfb.fb.RemoteDesktop;
import com.wincornixdorf.vnc.rfb.fb.VNCEncoding;

public class FBDecoderCoRRE extends FBDecoder {

    public FBDecoderCoRRE( RemoteDesktop data) {
        super( data);
    }

    public VNCEncoding getEncoding() {
        return VNCEncoding.CoRRE;
    }

    public void process( DataInputStream is, int x, int y, int w, int h) throws Exception {
        int nSubrects = is.readInt();
        int bpp = rd.getBytesPerPixel();

        byte[] bg_buf = new byte[ rd.getBytesPerPixel()];
        is.readFully( bg_buf);
        Color pixel = null;

        switch ( bpp) {
        	case 1  : pixel = new Color( rd.cm08.getRGB( bg_buf[ 0] & 0xFF)); break;
            case 2  : pixel = decode16BitColor( bg_buf, 0); break;
            default : pixel = new Color( crunch( bg_buf));
        }

        rd.fillRect( x, y, w, h, pixel);

        byte[] buf = new byte[ nSubrects * ( rd.getBytesPerPixel() + 4)];
        is.readFully( buf);

        //if ( rfb.rec != null) {
        //    rfb.rec.writeIntBE( nSubrects);
        //    rfb.rec.write( bg_buf);
        //    rfb.rec.write( buf);
        //}

        int i = 0;

        for ( int j = 0; j < nSubrects; j++) {

            switch ( bpp) {
            	case 1  : pixel = new Color( rd.cm08.getRGB( buf[ i++] & 0xFF)); break;
                case 2  :
                    pixel = decode16BitColor( buf, i);
                    i += 2;
                break;
                default : 
                    pixel = new Color( buf[ i + 2] & 0xFF, buf[ i + 1] & 0xFF, buf[ i] & 0xFF);
                    i += 4;
                break;
            }

            int sx = x + ( buf[ i++] & 0xFF);
            int sy = y + ( buf[ i++] & 0xFF);
            int sw = buf[ i++] & 0xFF;
            int sh = buf[ i++] & 0xFF;

            rd.fillRect( sx, sy, sw, sh, pixel);
        }

        rd.srcRDesktop.newPixels( x, y, w, h);
    }
}
