package com.wincornixdorf.vnc.rfb.decoder;

import java.awt.Color;
import java.io.ByteArrayInputStream;
import java.io.DataInputStream;

import com.wincornixdorf.vnc.rfb.fb.RemoteDesktop;
import com.wincornixdorf.vnc.rfb.fb.VNCEncoding;

public class FBDecoderRRE extends FBDecoder {

    public FBDecoderRRE( RemoteDesktop rd) {
        super( rd);
    }

    public VNCEncoding getEncoding() {
        return VNCEncoding.RRE;
    }

    public void process( DataInputStream is, int x, int y, int w, int h) throws Exception {
        int nSubrects = is.readInt();

        byte[] bg_buf = new byte[ rd.getBytesPerPixel()];
        is.readFully( bg_buf);
        Color pixel;

        switch ( rd.getBytesPerPixel()) {
            case 1 :
                Color c = new Color( rd.cm08.getRGB( bg_buf[ 0] & 0xFF));
                rd.fillRect24( x, y, w, h, c);
            break;
            case 2 :
                pixel = decode16BitColor( bg_buf, 0);
                rd.fillRect24( x, y, w, h, pixel);
            break;
            default:
                pixel = new Color( bg_buf[ 2] & 0xFF, bg_buf[ 1] & 0xFF, bg_buf[ 0] & 0xFF);
                rd.fillRect24( x, y, w, h, pixel);
        }

        byte[] buf = new byte[ nSubrects * ( rd.getBytesPerPixel() + 8)];
        is.readFully( buf);
        DataInputStream ds = new DataInputStream( new ByteArrayInputStream( buf));

        //if (rfb.rec != null) {
        //    rfb.rec.writeIntBE(nSubrects);
        //    rfb.rec.write(bg_buf);
        //    rfb.rec.write(buf);
        //}

        for ( int j = 0; j < nSubrects; j++) {
            switch ( rd.getBytesPerPixel()) {
                case 1 :
                    pixel = new Color( rd.cm08.getRGB( ds.readUnsignedByte()));
                break;
                case 2 :
                    ds.readFully( bg_buf);
                    pixel = decode16BitColor( bg_buf, 0);
                break;
                default:
                    ds.skip( 4);
                    pixel = new Color( buf[ j * 12 + 2] & 0xFF, buf[ j * 12 + 1] & 0xFF, buf[ j * 12] & 0xFF);
            }

            int sx = x + ds.readUnsignedShort();
            int sy = y + ds.readUnsignedShort();
            int sw =     ds.readUnsignedShort();
            int sh =     ds.readUnsignedShort();

            rd.fillRect( sx, sy, sw, sh, pixel);
        }

        rd.srcRDesktop.newPixels( x, y, w, h);
    }
}
