package com.wincornixdorf.vnc.rfb.decoder;

import java.awt.Color;
import java.io.DataInputStream;
import java.util.zip.Inflater;

import com.wincornixdorf.vnc.rfb.fb.RemoteDesktop;
import com.wincornixdorf.vnc.rfb.fb.VNCEncoding;

public class FBDecoderZLib extends FBDecoderZRLE {
    private byte[]     zlibBuf         = null;
    private int        zlibBufLen      = 0;
    private Inflater   zlibInflater    = new Inflater();

    public FBDecoderZLib( RemoteDesktop rd) {
        super( rd);
    }

    public VNCEncoding getEncoding() {
        return VNCEncoding.Zlib;
    }

    public void process( DataInputStream is, int x, int y, int w, int h) throws Exception {
        int nBytes = is.readInt();
        int bpp = rd.getBytesPerPixel();

        if ( zlibBuf == null || zlibBufLen < nBytes) {
            zlibBufLen = nBytes * 2;
            zlibBuf = new byte[ zlibBufLen];
        }

        is.readFully( zlibBuf, 0, nBytes);

/*		if (rfb.rec != null && rfb.recordFromBeginning) {
            rfb.rec.writeIntBE(nBytes);
            rfb.rec.write(zlibBuf, 0, nBytes);
        }*/

        zlibInflater.setInput( zlibBuf, 0, nBytes);

        byte[] buf = new byte[ w * bpp];

        switch (  bpp) {
            case 1  :
                for ( int dy = y; dy < y + h; dy++) {
                	zlibInflater.inflate( buf);
                    int offset = dy * rd.getFBW() + x;
                    for ( int i = 0; i < w; i++) {
                    	int cv = buf[ i];
                    	Color c = new Color( rd.cm08.getRed( cv) , rd.cm08.getGreen( cv), rd.cm08.getBlue( cv));
                    	rd.pixels24[ i + offset] = c.getRGB();
                    }

                    //if ( rfb.rec != null && !rfb.recordFromBeginning)
                    //rfb.rec.write(buf);
                    
                    //if ( rfb.rec != null && !rfb.recordFromBeginning)
                    //rfb.rec.write( rd.pixels08, dy * rd.getFBW() + x, w);
                }
            break;
            case 2  :
                for ( int dy = y; dy < y + h; dy++) {
                    zlibInflater.inflate( buf);
                    int offset = dy * rd.getFBW() + x;
                    for ( int i = 0; i < w; i++)
                        rd.pixels24[ i + offset] = decode16BitColor( buf, i * bpp).getRGB();

                    //if ( rfb.rec != null && !rfb.recordFromBeginning)
                    //rfb.rec.write(buf);
                }
            break;
            default :
                for ( int dy = y; dy < y + h; dy++) {
                    zlibInflater.inflate( buf);
                    int offset = dy * rd.getFBW() + x;
                    for ( int i = 0; i < w; i++) {
                        rd.pixels24[ offset + i] =  ( buf[ i * bpp + 2] & 0xFF) << 16 |
                                                    ( buf[ i * bpp + 1] & 0xFF) <<  8 |
                                                    ( buf[ i * bpp    ] & 0xFF);
                    }
                    //if ( rfb.rec != null && !rfb.recordFromBeginning)
                    //rfb.rec.write(buf);
                }
            break;
        }

        rd.srcRDesktop.newPixels( x, y, w, h);
    }
}
